#define HASH_SZ 97

typedef struct _node {
    STRING key;
    VOID *data;
    struct _node *next;
} HASH_NODE;

typedef struct {
    INT size;
    HASH_NODE **buckets;
} HASH_TABLE;

extern HASH_TABLE *hash_create();
extern VOID hash_destroy();
extern VOID *hash_search();
extern VOID hash_traverse();
extern VOID hash_purge();

#ifdef HASH_STATS
extern VOID hash_stats();
#endif
